Subject: Re: Git-aware HTTP transport

From: "H. Peter Anvin" <[email-masked]>
Date: Thu, 28 Aug 2008 10:43:28 -0700

[email-masked] wrote:
> except that HTTP cannot transport binary data, if you feed it binary 
> data it then encodes it into 7-bit safe forms for transport.

Total utter bunk.  You're thinking of email and news, which had to deal 
with broken legacy code.

HTTP has *always* been binary clean.  It does not encode anything into 
7-bit safe anything.  The only "encoding" that it ever does is 
HTTP/1.1's chunked encoding, which is a way to deal with the fact that 
it might not always know the total length of the data before it starts 
the transfer; it sends the data in arbitrary-sized "chunks" prefixed by 
a byte count.  It does this to support connection caching in HTTP/1.1; 
HTTP/1.0 would simply close the connection to indicate end of (binary) data.

	-hpa